#ifndef _SONAR_CLIENT_H_
#define _SONAR_CLIENT_H_

#include <pktIO.h>

struct reflex;

#ifdef __cplusplus
extern "C"
{
#endif
  
  struct reflexSonar {
    int port;
    
    /* ---------------------------------------- */

    int (*updateRpl) (struct reflex *reflex, int rv, unsigned char id, int ts,
		      int count, unsigned char *sonarId,
		      unsigned short *sonarValue);
    
    int (*rptRpl)    (struct reflex *reflex, int rv, unsigned char id, int ts);
    
    int (*unknownRpl) (struct reflex *reflex, unsigned char id,
		       unsigned char size,
		       unsigned char *buffer, unsigned char opcode);
    
    /* ---------------------------------------- */

    int (*rpt)        (struct reflex *reflex, unsigned char id, int ts,
		       int count, unsigned char *sonarId,
		       unsigned short *sonarValue);
  
    /* ---------------------------------------- */

    int (*updateReq)  (struct reflex *reflex, unsigned char id,
		       int ts);
    
    int (*rptReq)     (struct reflex *reflex, unsigned char id,
		       int echoDelay, int pingDelay, int setDelay,
		       unsigned char mode);
    
    /* ---------------------------------------- */

    int (*handlePort) (struct reflex *reflex, int size,
		       unsigned char *buffer,
		       unsigned char id, unsigned char opcode);

    int (*destroy)    (struct reflexSonar *ptr);
  };

  struct reflexSonar * reflexSonarNew (int port);
#ifdef __cplusplus
}
#endif

#endif
